/*
 * Copyright 2023 NXP
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
!!GlobalInfo
product: Peripherals v13.0
processor: LPC865
package_id: LPC865M201JBD64
mcu_data: ksdk2_0
processor_version: 0.14.4
board: LPCXpresso860MAX
functionalGroups:
- name: BOARD_InitPeripherals
  UUID: 9fe6f390-d46e-4bfd-ab54-d5805709c7dd
  called_from_default_init: true
  selectedCore: core0
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/

/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
component:
- type: 'system'
- type_id: 'system'
- global_system_definitions:
  - user_definitions: ''
  - user_includes: ''
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/

/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
component:
- type: 'uart_cmsis_common'
- type_id: 'uart_cmsis_common_9cb8e302497aa696fdbb5a4fd622c2a8'
- global_USART_CMSIS_common:
  - quick_selection: 'default'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/

/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
component:
- type: 'gpio_adapter_common'
- type_id: 'gpio_adapter_common_57579b9ac814fe26bf95df0a384c36b6'
- global_gpio_adapter_common:
  - quick_selection: 'default'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */

/***********************************************************************************************************************
 * Included files
 **********************************************************************************************************************/
#include "peripherals.h"

/***********************************************************************************************************************
 * BOARD_InitPeripherals functional group
 **********************************************************************************************************************/
/***********************************************************************************************************************
 * MRT0 initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'MRT0'
- type: 'mrt'
- mode: 'general_config'
- custom_name_enabled: 'false'
- type_id: 'mrt_ec4ff9f008b2eee803e5f398b3b3325f'
- functional_group: 'BOARD_InitPeripherals'
- peripheral: 'MRT0'
- config_sets:
  - fsl_mrt:
    - mrtOperationMode: 'HSM'
    - clockSettingMRT:
      - clockSource: 'BusInterfaceClock'
      - clockSourceFreq: 'BOARD_BootClockFRO60M'
    - mrtChannels:
      - 0:
        - mrtChannelPrefixID: 'Channel_0'
        - channelNumber: 'kMRT_Channel_0'
        - timerMode: 'kMRT_RepeatMode'
        - timerValueStr: '60000'
        - startTimer: 'true'
        - enableInterruptRequest: 'true'
    - interruptVector:
      - enableInterrupt: 'true'
      - interrupt:
        - IRQn: 'MRT0_IRQn'
        - enable_interrrupt: 'enabled'
        - enable_priority: 'true'
        - priority: '2'
        - enable_custom_name: 'false'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */
const mrt_config_t MRT0_config = {
  .enableMultiTask = false
};

static void MRT0_init(void) {
  /* MRT0 peripheral initialization */
  MRT_Init(MRT0_PERIPHERAL, &MRT0_config);
  /* MRT channel 0 of MRT0 peripheral initialization */
  MRT_SetupChannelMode(MRT0_PERIPHERAL, MRT0_CHANNEL_0, MRT0_CHANNEL_0_MODE);
  /* MRT channel 0 interrupt of MRT0 peripheral initialization */
  MRT_EnableInterrupts(MRT0_PERIPHERAL, MRT0_CHANNEL_0, kMRT_TimerInterruptEnable);
  /* Interrupt vector MRT0_IRQn priority settings in the NVIC. */
  NVIC_SetPriority(MRT0_IRQN, MRT0_IRQ_PRIORITY);
  /* Enable interrupt MRT0_IRQn request in the NVIC. */
  EnableIRQ(MRT0_IRQN);
  /* MRT channel 0 start of MRT0 peripheral initialization */
  MRT_StartTimer(MRT0_PERIPHERAL, MRT0_CHANNEL_0, MRT0_CHANNEL_0_TICKS);
}

/***********************************************************************************************************************
 * FreeMASTER initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'FreeMASTER'
- type: 'freemaster'
- mode: 'general'
- custom_name_enabled: 'false'
- type_id: 'freemaster_14894d49d87e02d0dca5f799e22554da'
- functional_group: 'BOARD_InitPeripherals'
- config_sets:
  - freemaster_config:
    - FMSTR_DISABLE: 'false'
    - initFreemaster: 'true'
    - generalConfig:
      - commInterface: 'serial'
      - interruptMode: 'polling'
      - initType: 'false'
      - serialConfig:
        - peripheralUART: 'USART0'
        - clockSource: 'genericUartClockSource'
        - clockSourceFreq: 'BOARD_BootClockFRO60M'
        - baudRate_Bps: '115200'
        - parityMode_usart: 'kUSART_ParityDisabled'
        - stopBitCount_usart: 'kUSART_OneStopBit'
        - bitCountPerChar: 'kUSART_8BitsPerChar'
        - enableUserInit: 'false'
        - user_init:
          - initFunctionID: 'SERIAL_communication_init'
        - enable_rx_tx_irq: 'true'
        - interrupt_rx_tx:
          - IRQn: 'USART0_IRQn'
          - enable_interrrupt: 'enabled'
          - enable_priority: 'false'
          - priority: '0'
          - useDefaultISR: 'true'
          - enable_custom_name: 'false'
          - handler_custom_name: ''
        - quick_selection: 'QuickSelection1'
      - pdbdmConfig:
        - FMSTR_PDBDM_USER_BUFFER: 'false'
        - pdbdmBuffer: 'default'
      - FMSTR_COMM_BUFFER_SIZE: 'autoSize'
      - FMSTR_COMM_RQUEUE_SIZE: '32'
      - FMSTR_USE_SCOPE: '1'
      - FMSTR_MAX_SCOPE_VARS: '8'
      - FMSTR_REC_FLOAT_TRIG: 'false'
      - recorders:
        - 0:
          - recID:
            - enableCustomID: 'false'
          - nameRec: 'Description of recorder 0'
          - recBuff:
            - customBuffer: 'false'
            - bufferAddress: 'FreeMASTER_RecBuffer0'
            - bufferExternDef: 'FMSTR_U8 FreeMASTER_RecBuffer0[1024]'
            - bufferSize: '512'
          - basePeriod_ns: '0'
          - recInit: 'true'
      - FMSTR_USE_TSA: 'true'
      - FMSTR_USE_TSA_INROM: 'true'
      - FMSTR_USE_TSA_SAFETY: 'true'
      - FMSTR_USE_TSA_DYNAMIC: 'false'
      - tsaBufferInit: 'false'
      - tsaBuff:
        - customBuffer: 'false'
        - bufferAddress: 'FreeMASTER_TSA_buffer'
        - bufferExternDef: 'FMSTR_ADDR FreeMASTER_TSA_buffer[TSA_TABLE_SIZE]'
        - bufferSize: '(5 * sizeof(FMSTR_TSA_ENTRY))'
      - pipes: []
      - FMSTR_USE_READMEM: 'true'
      - FMSTR_USE_WRITEMEM: 'true'
      - FMSTR_USE_WRITEMEMMASK: 'true'
      - passR: ''
      - passRW: ''
      - passRWF: ''
      - FMSTR_USE_HASHED_PASSWORDS: 'false'
      - FMSTR_USE_APPCMD: 'false'
      - FMSTR_APPCMD_BUFF_SIZE: '32'
      - FMSTR_MAX_APPCMD_CALLS: '8'
      - FMSTR_DEBUG_LEVEL: '0'
      - FMSTR_DEBUG_PRINTF: 'debug_console'
      - FMSTR_DEBUG_TX: 'false'
      - FMSTR_CUSTOM_INCLUDES: ''
      - FMSTR_CUSTOM_OPTIONS: ''
    - freemaster_codegenerator: []
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */
/* USART configuration structure */
usart_config_t FreeMASTER_serial_config;
/* Recorder0 configuration */
FMSTR_U8 FreeMASTER_RecBuffer0[FREEMASTER_REC_0_SIZE];
FMSTR_REC_BUFF FreeMASTER_Recorder_0 = {
  .name = "Description of recorder 0",
  .addr = (FMSTR_ADDR)FreeMASTER_RecBuffer0,
  .size = (FMSTR_SIZE) sizeof(FreeMASTER_RecBuffer0),
  .basePeriod_ns = 0UL
};

static void FreeMASTER_init(void) {
  /* Serial communication peripheral initialization */

  /* Get USART default configuration and modify it */
  USART_GetDefaultConfig(&FreeMASTER_serial_config);

  FreeMASTER_serial_config.baudRate_Bps = FREEMASTER_SERIAL_PERIPHERAL_BAUDRATE;
  FreeMASTER_serial_config.parityMode = kUSART_ParityDisabled;
  FreeMASTER_serial_config.stopBitCount = kUSART_OneStopBit;
  FreeMASTER_serial_config.bitCountPerChar = kUSART_8BitsPerChar;

  /* Initialize USART module. */
  USART_Init(FREEMASTER_SERIAL_PERIPHERAL, &FreeMASTER_serial_config, FREEMASTER_SERIAL_PERIPHERAL_CLK_FREQ);
  /* FreeMASTER middleware initialization */
  FMSTR_Init();
  /* FreeMASTER recorder 0 configuration initialization  */
  FMSTR_RecorderCreate(0, &FreeMASTER_Recorder_0);
}

/***********************************************************************************************************************
 * Initialization functions
 **********************************************************************************************************************/
void BOARD_InitPeripherals(void)
{
  /* Initialize components */
  MRT0_init();
  FreeMASTER_init();
}

/***********************************************************************************************************************
 * BOARD_InitBootPeripherals function
 **********************************************************************************************************************/
void BOARD_InitBootPeripherals(void)
{
  BOARD_InitPeripherals();
}
