/*
 * Copyright 2023 NXP
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

#ifndef _PERIPHERALS_H_
#define _PERIPHERALS_H_

/***********************************************************************************************************************
 * Included files
 **********************************************************************************************************************/
#include "fsl_common.h"
#include "fsl_mrt.h"
#include "fsl_usart.h"
#include "fsl_clock.h"
#include "freemaster.h"
#include "freemaster_serial_miniusart.h"

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/***********************************************************************************************************************
 * Definitions
 **********************************************************************************************************************/
/* Definitions for BOARD_InitPeripherals functional group */
/* Definition of peripheral ID */
#define MRT0_PERIPHERAL MRT0
/* Definition of channel 0 ID */
#define MRT0_CHANNEL_0 kMRT_Channel_0
/* Definition of channel 0 mode */
#define MRT0_CHANNEL_0_MODE kMRT_RepeatMode
/* Definition of channel 0 timer in ticks */
#define MRT0_CHANNEL_0_TICKS 60000U
/* MRT0 interrupt vector ID (number). */
#define MRT0_IRQN MRT0_IRQn
/* MRT0 interrupt vector priority. */
#define MRT0_IRQ_PRIORITY 2
/* MRT0 interrupt handler identifier. */
#define MRT0_IRQHANDLER MRT0_IRQHandler
/* FreeMASTER_Recorder_0's buffer size definition */
#define FREEMASTER_REC_0_SIZE 512
/* Definition of peripheral ID */
#define FREEMASTER_SERIAL_PERIPHERAL ((USART_Type *)USART0)
/* Definition of the clock source frequency */
#define FREEMASTER_SERIAL_PERIPHERAL_CLK_FREQ 60000000UL
/* Definition of the Baud rate */
#define FREEMASTER_SERIAL_PERIPHERAL_BAUDRATE 115200UL

/***********************************************************************************************************************
 * Global variables
 **********************************************************************************************************************/
extern const mrt_config_t MRT0_config;
/* USART configuration structure */
extern usart_config_t FreeMASTER_serial_config;
/* Recorder0 configuration */
extern FMSTR_U8 FreeMASTER_RecBuffer0[FREEMASTER_REC_0_SIZE];

/***********************************************************************************************************************
 * Initialization functions
 **********************************************************************************************************************/

void BOARD_InitPeripherals(void);

/***********************************************************************************************************************
 * BOARD_InitBootPeripherals function
 **********************************************************************************************************************/
void BOARD_InitBootPeripherals(void);

#if defined(__cplusplus)
}
#endif

#endif /* _PERIPHERALS_H_ */
