/*
 * Copyright 2023 NXP
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

/* clang-format off */
/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
!!GlobalInfo
product: Pins v14.0
processor: LPC865
package_id: LPC865M201JBD64
mcu_data: ksdk2_0
processor_version: 0.14.4
board: LPCXpresso860MAX
pin_labels:
- {pin_num: '16', pin_signal: PIO0_11, label: 'P0_11-I2C0_SDA/P3[40]/J1[18]/J3[7]', identifier: OVERCURRENT}
- {pin_num: '18', pin_signal: PIO1_1, label: 'P1_1-PWM_CB/J5[5]', identifier: PWM_CB}
- {pin_num: '19', pin_signal: PIO0_16, label: 'P0_16-PWM_CT/J5[7]', identifier: PWM_CT}
- {pin_num: '20', pin_signal: PIO1_2, label: 'P1_2-PWM_BB/J5[9]', identifier: PWM_BB}
- {pin_num: '21', pin_signal: PIO0_27, label: 'P0_27-PWM_BT/J5[11]', identifier: PWM_BT}
- {pin_num: '35', pin_signal: PIO1_5, label: 'J5[13]/P1_5-PWM_AB', identifier: PWM_AB}
- {pin_num: '38', pin_signal: PIO1_6, label: 'J5[15]/P1_6-PWM_AT', identifier: PWM_AT}
- {pin_num: '45', pin_signal: PIO0_7/ADC_0, label: 'J6[12]/P3[20]/PIO0_7/ADC_0', identifier: TEST_PIN}
- {pin_num: '49', pin_signal: PIO0_14/ACMP_I3/ADC_2, label: 'P3[18]/J6[8]/PIO0_14-ADC_2-ACMP_I3', identifier: TP_POI14_J6;TP_POI14_J6_8;CUR_DCB;CUR_DCB_J6_8}
- {pin_num: '51', pin_signal: PIO0_23/ADC_3/ACMP_I4, label: 'P3[17]/J6[6]/PIO0_23-ADC_3-ACMP_I4', identifier: TP_PIO23_;TP_PIO23_J6_6}
- {pin_num: '57', pin_signal: PIO0_21/ADC_5, label: 'J6[2]/J2[12]/P3[15]/P3[46]/PIO0_21/ADC_5', identifier: TEST_PIN2}
- {pin_num: '58', pin_signal: PIO0_20/ADC_6, label: 'J1[1]/J2[14/P3[45/P0_20-BEMF_A', identifier: CUR_A}
- {pin_num: '60', pin_signal: PIO0_19/ADC_7, label: 'J1[3]/J2[16]/P3[44]/P0_19-BEMF_B', identifier: CUR_B}
- {pin_num: '61', pin_signal: PIO0_18/ADC_8, label: 'J1[5]/J1[6]/P3[43]/P0_18-BEMF_C', identifier: CUR_C}
- {pin_num: '63', pin_signal: PIO0_17/ADC_9, label: 'J1[7]/J1[8]/P3[42]/P0_17-VOLT_DCB', identifier: VOLT_DCB}
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */
/* clang-format on */

#include "fsl_common.h"
#include "fsl_gpio.h"
#include "fsl_iocon.h"
#include "fsl_swm.h"
#include "pin_mux.h"

/* FUNCTION ************************************************************************************************************
 *
 * Function Name : BOARD_InitBootPins
 * Description   : Calls initialization functions.
 *
 * END ****************************************************************************************************************/
void BOARD_InitBootPins(void)
{
    BOARD_InitPins();
    BOARD_InitLEDsPins();
    BOARD_InitBUTTONsPins();
    BOARD_InitUSART();
    BOARD_InitFTM0();
    BOARD_InitADC();
    BOARD_InitACOMP();
}

/* clang-format off */
/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
BOARD_InitPins:
- options: {callFromInitBoot: 'true', coreID: core0, enableClock: 'true'}
- pin_list: []
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */
/* clang-format on */

/* FUNCTION ************************************************************************************************************
 *
 * Function Name : BOARD_InitPins
 * Description   : Configures pin routing and optionally pin electrical features.
 *
 * END ****************************************************************************************************************/
/* Function assigned for the Cortex-M0P */
void BOARD_InitPins(void)
{
}

/* clang-format off */
/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
BOARD_InitLEDsPins:
- options: {callFromInitBoot: 'true', coreID: core0, enableClock: 'true'}
- pin_list:
  - {pin_num: '4', peripheral: GPIO, signal: 'PIO0, 12', pin_signal: PIO0_12, identifier: LED_RED, direction: OUTPUT, gpio_init_state: 'true', mode: inactive, invert: disabled,
    hysteresis: enabled, opendrain: enabled, smode: bypass, clkdiv: div0}
  - {pin_num: '9', peripheral: GPIO, signal: 'PIO1, 12', pin_signal: PIO1_12, direction: OUTPUT, gpio_init_state: 'true', mode: inactive, invert: disabled, hysteresis: enabled,
    opendrain: enabled, smode: bypass, clkdiv: div0}
  - {pin_num: '10', peripheral: GPIO, signal: 'PIO0, 28', pin_signal: PIO0_28/WKTCLKIN, direction: OUTPUT, gpio_init_state: 'true', mode: inactive, invert: disabled,
    hysteresis: enabled, opendrain: enabled, smode: bypass, clkdiv: div0}
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */
/* clang-format on */

/* FUNCTION ************************************************************************************************************
 *
 * Function Name : BOARD_InitLEDsPins
 * Description   : Configures pin routing and optionally pin electrical features.
 *
 * END ****************************************************************************************************************/
/* Function assigned for the Cortex-M0P */
void BOARD_InitLEDsPins(void)
{
    /* Enables clock for IOCON.: enable */
    CLOCK_EnableClock(kCLOCK_Iocon);
    /* Enables the clock for the GPIO0 module */
    CLOCK_EnableClock(kCLOCK_Gpio0);
    /* Enables the clock for the GPIO1 module */
    CLOCK_EnableClock(kCLOCK_Gpio1);

    gpio_pin_config_t LED_RED_config = {
        .pinDirection = kGPIO_DigitalOutput,
        .outputLogic = 1U,
    };
    /* Initialize GPIO functionality on pin PIO0_12 (pin 4)  */
    GPIO_PinInit(BOARD_INITLEDSPINS_LED_RED_GPIO, BOARD_INITLEDSPINS_LED_RED_PORT, BOARD_INITLEDSPINS_LED_RED_PIN, &LED_RED_config);

    gpio_pin_config_t LED_BLUE_config = {
        .pinDirection = kGPIO_DigitalOutput,
        .outputLogic = 1U,
    };
    /* Initialize GPIO functionality on pin PIO0_28 (pin 10)  */
    GPIO_PinInit(BOARD_INITLEDSPINS_LED_BLUE_GPIO, BOARD_INITLEDSPINS_LED_BLUE_PORT, BOARD_INITLEDSPINS_LED_BLUE_PIN, &LED_BLUE_config);

    gpio_pin_config_t LED_GREEN_config = {
        .pinDirection = kGPIO_DigitalOutput,
        .outputLogic = 1U,
    };
    /* Initialize GPIO functionality on pin PIO1_12 (pin 9)  */
    GPIO_PinInit(BOARD_INITLEDSPINS_LED_GREEN_GPIO, BOARD_INITLEDSPINS_LED_GREEN_PORT, BOARD_INITLEDSPINS_LED_GREEN_PIN, &LED_GREEN_config);

    const uint32_t LED_RED = (/* No addition pin function */
                              IOCON_PIO_MODE_INACT |
                              /* Enable hysteresis */
                              IOCON_PIO_HYS_EN |
                              /* Input not invert */
                              IOCON_PIO_INV_DI |
                              /* Enables Open-drain function */
                              IOCON_PIO_OD_EN |
                              /* Bypass input filter */
                              IOCON_PIO_SMODE_BYPASS |
                              /* IOCONCLKDIV0 */
                              IOCON_PIO_CLKDIV0);
    /* PIO0 PIN12 (coords: 4) is configured as GPIO, PIO0, 12. */
    IOCON_PinMuxSet(IOCON, IOCON_INDEX_PIO0_12, LED_RED);

    const uint32_t LED_BLUE = (/* No addition pin function */
                               IOCON_PIO_MODE_INACT |
                               /* Enable hysteresis */
                               IOCON_PIO_HYS_EN |
                               /* Input not invert */
                               IOCON_PIO_INV_DI |
                               /* Enables Open-drain function */
                               IOCON_PIO_OD_EN |
                               /* Bypass input filter */
                               IOCON_PIO_SMODE_BYPASS |
                               /* IOCONCLKDIV0 */
                               IOCON_PIO_CLKDIV0);
    /* PIO0 PIN28 (coords: 10) is configured as GPIO, PIO0, 28. */
    IOCON_PinMuxSet(IOCON, IOCON_INDEX_PIO0_28, LED_BLUE);

    const uint32_t LED_GREEN = (/* No addition pin function */
                                IOCON_PIO_MODE_INACT |
                                /* Enable hysteresis */
                                IOCON_PIO_HYS_EN |
                                /* Input not invert */
                                IOCON_PIO_INV_DI |
                                /* Enables Open-drain function */
                                IOCON_PIO_OD_EN |
                                /* Bypass input filter */
                                IOCON_PIO_SMODE_BYPASS |
                                /* IOCONCLKDIV0 */
                                IOCON_PIO_CLKDIV0);
    /* PIO1 PIN12 (coords: 9) is configured as GPIO, PIO1, 12. */
    IOCON_PinMuxSet(IOCON, IOCON_INDEX_PIO1_12, LED_GREEN);
}

/* clang-format off */
/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
BOARD_InitSWD_DEBUGPins:
- options: {callFromInitBoot: 'false', coreID: core0, enableClock: 'true'}
- pin_list:
  - {pin_num: '12', peripheral: SWD, signal: SWCLK, pin_signal: SWCLK/PIO0_3, mode: pullUp, invert: disabled, hysteresis: enabled, opendrain: disabled, smode: bypass,
    clkdiv: div0}
  - {pin_num: '14', peripheral: SWD, signal: SWDIO, pin_signal: SWDIO/PIO0_2, mode: pullUp, invert: disabled, hysteresis: enabled, opendrain: disabled, smode: bypass,
    clkdiv: div0}
  - {pin_num: '5', peripheral: SYSCON, signal: RESET, pin_signal: RESET/PIO0_5, mode: pullUp, invert: disabled, hysteresis: enabled, opendrain: disabled, smode: bypass,
    clkdiv: div0}
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */
/* clang-format on */

/* FUNCTION ************************************************************************************************************
 *
 * Function Name : BOARD_InitSWD_DEBUGPins
 * Description   : Configures pin routing and optionally pin electrical features.
 *
 * END ****************************************************************************************************************/
/* Function assigned for the Cortex-M0P */
void BOARD_InitSWD_DEBUGPins(void)
{
    /* Enables clock for IOCON.: enable */
    CLOCK_EnableClock(kCLOCK_Iocon);
    /* Enables clock for switch matrix.: enable */
    CLOCK_EnableClock(kCLOCK_Swm);

    const uint32_t DEBUG_SWD_SWDIO = (/* Selects pull-up function */
                                      IOCON_PIO_MODE_PULLUP |
                                      /* Enable hysteresis */
                                      IOCON_PIO_HYS_EN |
                                      /* Input not invert */
                                      IOCON_PIO_INV_DI |
                                      /* Disables Open-drain function */
                                      IOCON_PIO_OD_DI |
                                      /* Bypass input filter */
                                      IOCON_PIO_SMODE_BYPASS |
                                      /* IOCONCLKDIV0 */
                                      IOCON_PIO_CLKDIV0);
    /* PIO0 PIN2 (coords: 14) is configured as SWD, SWDIO. */
    IOCON_PinMuxSet(IOCON, IOCON_INDEX_PIO0_2, DEBUG_SWD_SWDIO);

    const uint32_t DEBUG_SWD_SWCLK = (/* Selects pull-up function */
                                      IOCON_PIO_MODE_PULLUP |
                                      /* Enable hysteresis */
                                      IOCON_PIO_HYS_EN |
                                      /* Input not invert */
                                      IOCON_PIO_INV_DI |
                                      /* Disables Open-drain function */
                                      IOCON_PIO_OD_DI |
                                      /* Bypass input filter */
                                      IOCON_PIO_SMODE_BYPASS |
                                      /* IOCONCLKDIV0 */
                                      IOCON_PIO_CLKDIV0);
    /* PIO0 PIN3 (coords: 12) is configured as SWD, SWCLK. */
    IOCON_PinMuxSet(IOCON, IOCON_INDEX_PIO0_3, DEBUG_SWD_SWCLK);

    const uint32_t IOCON_INDEX_PIO0_5_config = (/* Selects pull-up function */
                                                IOCON_PIO_MODE_PULLUP |
                                                /* Enable hysteresis */
                                                IOCON_PIO_HYS_EN |
                                                /* Input not invert */
                                                IOCON_PIO_INV_DI |
                                                /* Disables Open-drain function */
                                                IOCON_PIO_OD_DI |
                                                /* Bypass input filter */
                                                IOCON_PIO_SMODE_BYPASS |
                                                /* IOCONCLKDIV0 */
                                                IOCON_PIO_CLKDIV0);
    /* PIO0 PIN5 (coords: 5) is configured as SYSCON, RESET. */
    IOCON_PinMuxSet(IOCON, IOCON_INDEX_PIO0_5, IOCON_INDEX_PIO0_5_config);

    /* SWCLK connect to P0_3 */
    SWM_SetFixedPinSelect(SWM0, kSWM_SWCLK, true);

    /* SWDIO connect to P0_2 */
    SWM_SetFixedPinSelect(SWM0, kSWM_SWDIO, true);

    /* RESETN connect to P0_5 */
    SWM_SetFixedPinSelect(SWM0, kSWM_RESETN, true);

    /* Disable clock for switch matrix. */
    CLOCK_DisableClock(kCLOCK_Swm);
}

/* clang-format off */
/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
BOARD_InitBUTTONsPins:
- options: {callFromInitBoot: 'true', coreID: core0, enableClock: 'true'}
- pin_list:
  - {pin_num: '6', peripheral: GPIO, signal: 'PIO0, 4', pin_signal: PIO0_4/ADC_11, direction: INPUT, mode: pullUp, invert: disabled, hysteresis: enabled, opendrain: disabled,
    smode: bypass, clkdiv: div0}
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */
/* clang-format on */

/* FUNCTION ************************************************************************************************************
 *
 * Function Name : BOARD_InitBUTTONsPins
 * Description   : Configures pin routing and optionally pin electrical features.
 *
 * END ****************************************************************************************************************/
/* Function assigned for the Cortex-M0P */
void BOARD_InitBUTTONsPins(void)
{
    /* Enables clock for IOCON.: enable */
    CLOCK_EnableClock(kCLOCK_Iocon);
    /* Enables the clock for the GPIO0 module */
    CLOCK_EnableClock(kCLOCK_Gpio0);

    gpio_pin_config_t SW2_config = {
        .pinDirection = kGPIO_DigitalInput,
        .outputLogic = 0U,
    };
    /* Initialize GPIO functionality on pin PIO0_4 (pin 6)  */
    GPIO_PinInit(BOARD_INITBUTTONSPINS_SW2_GPIO, BOARD_INITBUTTONSPINS_SW2_PORT, BOARD_INITBUTTONSPINS_SW2_PIN, &SW2_config);

    const uint32_t SW2 = (/* Selects pull-up function */
                          IOCON_PIO_MODE_PULLUP |
                          /* Enable hysteresis */
                          IOCON_PIO_HYS_EN |
                          /* Input not invert */
                          IOCON_PIO_INV_DI |
                          /* Disables Open-drain function */
                          IOCON_PIO_OD_DI |
                          /* Bypass input filter */
                          IOCON_PIO_SMODE_BYPASS |
                          /* IOCONCLKDIV0 */
                          IOCON_PIO_CLKDIV0);
    /* PIO0 PIN4 (coords: 6) is configured as GPIO, PIO0, 4. */
    IOCON_PinMuxSet(IOCON, IOCON_INDEX_PIO0_4, SW2);

    /* Disable clock for switch matrix. */
    CLOCK_DisableClock(kCLOCK_Swm);
}

/* clang-format off */
/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
BOARD_InitUSART:
- options: {callFromInitBoot: 'true', coreID: core0, enableClock: 'true'}
- pin_list:
  - {pin_num: '37', peripheral: USART0, signal: TXD, pin_signal: PIO1_17, mode: pullUp}
  - {pin_num: '36', peripheral: USART0, signal: RXD, pin_signal: PIO1_16, mode: pullUp}
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */
/* clang-format on */

/* FUNCTION ************************************************************************************************************
 *
 * Function Name : BOARD_InitUSART
 * Description   : Configures pin routing and optionally pin electrical features.
 *
 * END ****************************************************************************************************************/
/* Function assigned for the Cortex-M0P */
void BOARD_InitUSART(void)
{
    /* Enables clock for IOCON.: enable */
    CLOCK_EnableClock(kCLOCK_Iocon);
    /* Enables clock for switch matrix.: enable */
    CLOCK_EnableClock(kCLOCK_Swm);

    IOCON->PIO[44] = ((IOCON->PIO[44] &
                       /* Mask bits to zero which are setting */
                       (~(IOCON_PIO_MODE_MASK)))

                      /* Selects function mode (on-chip pull-up/pull-down resistor control).: Pull-up. Pull-up resistor
                       * enabled. */
                      | IOCON_PIO_MODE(PIO1_16_MODE_PULL_UP));

    IOCON->PIO[45] = ((IOCON->PIO[45] &
                       /* Mask bits to zero which are setting */
                       (~(IOCON_PIO_MODE_MASK)))

                      /* Selects function mode (on-chip pull-up/pull-down resistor control).: Pull-up. Pull-up resistor
                       * enabled. */
                      | IOCON_PIO_MODE(PIO1_17_MODE_PULL_UP));

    /* USART0_TXD connect to P1_17 */
    SWM_SetMovablePinSelect(SWM0, kSWM_USART0_TXD, kSWM_PortPin_P1_17);

    /* USART0_RXD connect to P1_16 */
    SWM_SetMovablePinSelect(SWM0, kSWM_USART0_RXD, kSWM_PortPin_P1_16);

    /* Disable clock for switch matrix. */
    CLOCK_DisableClock(kCLOCK_Swm);
}

/* clang-format off */
/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
BOARD_InitFTM0:
- options: {callFromInitBoot: 'true', coreID: core0, enableClock: 'true'}
- pin_list:
  - {pin_num: '18', peripheral: FTM0, signal: 'CH, 0', pin_signal: PIO1_1}
  - {pin_num: '19', peripheral: FTM0, signal: 'CH, 1', pin_signal: PIO0_16}
  - {pin_num: '20', peripheral: FTM0, signal: 'CH, 2', pin_signal: PIO1_2}
  - {pin_num: '21', peripheral: FTM0, signal: 'CH, 3', pin_signal: PIO0_27}
  - {pin_num: '35', peripheral: FTM0, signal: 'CH, 4', pin_signal: PIO1_5}
  - {pin_num: '38', peripheral: FTM0, signal: 'CH, 5', pin_signal: PIO1_6}
  - {peripheral: FTM0, signal: 'FLT, 0', pin_signal: ACMP_OUT}
  - {pin_num: '16', peripheral: GPIO, signal: 'PIO0, 11', pin_signal: PIO0_11, direction: INPUT}
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */
/* clang-format on */

/* FUNCTION ************************************************************************************************************
 *
 * Function Name : BOARD_InitFTM0
 * Description   : Configures pin routing and optionally pin electrical features.
 *
 * END ****************************************************************************************************************/
/* Function assigned for the Cortex-M0P */
void BOARD_InitFTM0(void)
{
    /* Enables clock for switch matrix.: enable */
    CLOCK_EnableClock(kCLOCK_Swm);
    /* Enables the clock for the GPIO0 module */
    CLOCK_EnableClock(kCLOCK_Gpio0);

    gpio_pin_config_t OVERCURRENT_config = {
        .pinDirection = kGPIO_DigitalInput,
        .outputLogic = 0U,
    };
    /* Initialize GPIO functionality on pin PIO0_11 (pin 16)  */
    GPIO_PinInit(BOARD_INITFTM0_OVERCURRENT_GPIO, BOARD_INITFTM0_OVERCURRENT_PORT, BOARD_INITFTM0_OVERCURRENT_PIN, &OVERCURRENT_config);
    /* Enables the clock for the FTM0 */
    CLOCK_EnableClock(kCLOCK_Ftm0);

    INPUTMUX->FTM0_FLT_INMUX[0] = ((INPUTMUX->FTM0_FLT_INMUX[0] &
                                    /* Mask bits to zero which are setting */
                                    (~(INPUTMUX_FTM0_FLT_INMUX_INP_MASK)))

                                   /* Trigger input number (decimal value) for DMA channel n (n = 0 to 12). 0 =
                                    * GPIO_INT4; 1 = GPIO_INT5; 2 = GPIO_INT6; 3 = GPIO_INT7; 4= ADC0_SEQA_IRQ; 5 =
                                    * ADC0_SEQB_IRQ; 6 = COMP0_OUT; 7 = FTM0_INIT_TRIG ORed with FTM0_EXT_TRIG; 8 =
                                    * FTM1_INIT_TRIG ORed with FTM1_EXT_TRIG; 9= Ored (FTM0_CH0, FTM0_CH1,..,
                                    * FTM0_CH5); 10 = Ored (FTM1_CH0, FTM1_CH1,.., FTM1_CH3); 11 = SDMA_TRIGOUT_A; 12 =
                                    * SDMA_TRIGOUT_B.: 0x06u */
                                   | INPUTMUX_FTM0_FLT_INMUX_INP(0x06u));

    /* FTM0_CH0 connect to kSWM_FTM_Selection1 */
    SWM_SetFlextimerPinSelect(SWM0, kSWM_FTM0_CH0, kSWM_FTM_Selection1);

    /* FTM0_CH1 connect to kSWM_FTM_Selection2 */
    SWM_SetFlextimerPinSelect(SWM0, kSWM_FTM0_CH1, kSWM_FTM_Selection2);

    /* FTM0_CH2 connect to kSWM_FTM_Selection2 */
    SWM_SetFlextimerPinSelect(SWM0, kSWM_FTM0_CH2, kSWM_FTM_Selection2);

    /* FTM0_CH3 connect to kSWM_FTM_Selection2 */
    SWM_SetFlextimerPinSelect(SWM0, kSWM_FTM0_CH3, kSWM_FTM_Selection2);

    /* FTM0_CH4 connect to kSWM_FTM_Selection1 */
    SWM_SetFlextimerPinSelect(SWM0, kSWM_FTM0_CH4, kSWM_FTM_Selection1);

    /* FTM0_CH5 connect to kSWM_FTM_Selection1 */
    SWM_SetFlextimerPinSelect(SWM0, kSWM_FTM0_CH5, kSWM_FTM_Selection1);

    SYSCON->FTMFLTCFG = ((SYSCON->FTMFLTCFG &
                          /* Mask bits to zero which are setting */
                          (~(SYSCON_FTMFLTCFG_FTM0_FAULT0_MUX_SEL_MASK)))

                         /* Mux selection FTM0 fault from external I/O or internal.: Select internal */
                         | SYSCON_FTMFLTCFG_FTM0_FAULT0_MUX_SEL(FTMFLTCFG_FTM0_FAULT0_MUX_SEL_INTERNAL));

    /* Disable clock for switch matrix. */
    CLOCK_DisableClock(kCLOCK_Swm);
}

/* clang-format off */
/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
BOARD_InitADC:
- options: {callFromInitBoot: 'true', coreID: core0, enableClock: 'true'}
- pin_list:
  - {pin_num: '58', peripheral: ADC0, signal: 'CH, 6', pin_signal: PIO0_20/ADC_6}
  - {pin_num: '60', peripheral: ADC0, signal: 'CH, 7', pin_signal: PIO0_19/ADC_7}
  - {pin_num: '61', peripheral: ADC0, signal: 'CH, 8', pin_signal: PIO0_18/ADC_8}
  - {pin_num: '63', peripheral: ADC0, signal: 'CH, 9', pin_signal: PIO0_17/ADC_9}
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */
/* clang-format on */

/* FUNCTION ************************************************************************************************************
 *
 * Function Name : BOARD_InitADC
 * Description   : Configures pin routing and optionally pin electrical features.
 *
 * END ****************************************************************************************************************/
/* Function assigned for the Cortex-M0P */
void BOARD_InitADC(void)
{
    /* Enables clock for switch matrix.: enable */
    CLOCK_EnableClock(kCLOCK_Swm);

    /* ADC_CHN6 connect to P0_20 */
    SWM_SetFixedPinSelect(SWM0, kSWM_ADC_CHN6, true);

    /* ADC_CHN7 connect to P0_19 */
    SWM_SetFixedPinSelect(SWM0, kSWM_ADC_CHN7, true);

    /* ADC_CHN8 connect to P0_18 */
    SWM_SetFixedPinSelect(SWM0, kSWM_ADC_CHN8, true);

    /* ADC_CHN9 connect to P0_17 */
    SWM_SetFixedPinSelect(SWM0, kSWM_ADC_CHN9, true);

    /* Disable clock for switch matrix. */
    CLOCK_DisableClock(kCLOCK_Swm);
}

/* clang-format off */
/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
BOARD_InitACOMP:
- options: {callFromInitBoot: 'true', coreID: core0, enableClock: 'true'}
- pin_list:
  - {pin_num: '49', peripheral: ACMP, signal: ACMP_IN3, pin_signal: PIO0_14/ACMP_I3/ADC_2}
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */
/* clang-format on */

/* FUNCTION ************************************************************************************************************
 *
 * Function Name : BOARD_InitACOMP
 * Description   : Configures pin routing and optionally pin electrical features.
 *
 * END ****************************************************************************************************************/
/* Function assigned for the Cortex-M0P */
void BOARD_InitACOMP(void)
{
    /* Enables clock for switch matrix.: enable */
    CLOCK_EnableClock(kCLOCK_Swm);

    /* ACMP_INPUT3 connect to P0_14 */
    SWM_SetFixedPinSelect(SWM0, kSWM_ACMP_INPUT3, true);

    /* Disable clock for switch matrix. */
    CLOCK_DisableClock(kCLOCK_Swm);
}
/***********************************************************************************************************************
 * EOF
 **********************************************************************************************************************/
