/*
 * Copyright 2023 NXP
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

#ifndef _PIN_MUX_H_
#define _PIN_MUX_H_

/*!
 * @addtogroup pin_mux
 * @{
 */

/***********************************************************************************************************************
 * API
 **********************************************************************************************************************/

#if defined(__cplusplus)
extern "C" {
#endif

/*!
 * @brief Calls initialization functions.
 *
 */
void BOARD_InitBootPins(void);

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitPins(void); /* Function assigned for the Cortex-M0P */

#define IOCON_PIO_CLKDIV0 0x00u      /*!<@brief IOCONCLKDIV0 */
#define IOCON_PIO_HYS_EN 0x20u       /*!<@brief Enable hysteresis */
#define IOCON_PIO_INV_DI 0x00u       /*!<@brief Input not invert */
#define IOCON_PIO_MODE_INACT 0x00u   /*!<@brief No addition pin function */
#define IOCON_PIO_OD_EN 0x0400u      /*!<@brief Enables Open-drain function */
#define IOCON_PIO_SMODE_BYPASS 0x00u /*!<@brief Bypass input filter */

/*! @name PIO0_12 (number 4), D1/SW1/P0_12-RED-ISP
  @{ */

/* Symbols to be used with GPIO driver */
#define BOARD_INITLEDSPINS_LED_RED_GPIO GPIO                 /*!<@brief GPIO peripheral base pointer */
#define BOARD_INITLEDSPINS_LED_RED_GPIO_PIN_MASK (1U << 12U) /*!<@brief GPIO pin mask */
#define BOARD_INITLEDSPINS_LED_RED_PORT 0U                   /*!<@brief PORT device index: 0 */
#define BOARD_INITLEDSPINS_LED_RED_PIN 12U                   /*!<@brief PORT pin number */
#define BOARD_INITLEDSPINS_LED_RED_PIN_MASK (1U << 12U)      /*!<@brief PORT pin mask */
                                                             /* @} */

/*! @name PIO1_12 (number 9), D2/P1_12-GREEN
  @{ */

/* Symbols to be used with GPIO driver */
#define BOARD_INITLEDSPINS_LED_GREEN_GPIO GPIO                 /*!<@brief GPIO peripheral base pointer */
#define BOARD_INITLEDSPINS_LED_GREEN_GPIO_PIN_MASK (1U << 12U) /*!<@brief GPIO pin mask */
#define BOARD_INITLEDSPINS_LED_GREEN_PORT 1U                   /*!<@brief PORT device index: 1 */
#define BOARD_INITLEDSPINS_LED_GREEN_PIN 12U                   /*!<@brief PORT pin number */
#define BOARD_INITLEDSPINS_LED_GREEN_PIN_MASK (1U << 12U)      /*!<@brief PORT pin mask */
                                                               /* @} */

/*! @name PIO0_28 (number 10), D3/P0_28-BLUE
  @{ */

/* Symbols to be used with GPIO driver */
#define BOARD_INITLEDSPINS_LED_BLUE_GPIO GPIO                 /*!<@brief GPIO peripheral base pointer */
#define BOARD_INITLEDSPINS_LED_BLUE_GPIO_PIN_MASK (1U << 28U) /*!<@brief GPIO pin mask */
#define BOARD_INITLEDSPINS_LED_BLUE_PORT 0U                   /*!<@brief PORT device index: 0 */
#define BOARD_INITLEDSPINS_LED_BLUE_PIN 28U                   /*!<@brief PORT pin number */
#define BOARD_INITLEDSPINS_LED_BLUE_PIN_MASK (1U << 28U)      /*!<@brief PORT pin mask */
                                                              /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitLEDsPins(void); /* Function assigned for the Cortex-M0P */

#define IOCON_PIO_CLKDIV0 0x00u      /*!<@brief IOCONCLKDIV0 */
#define IOCON_PIO_HYS_EN 0x20u       /*!<@brief Enable hysteresis */
#define IOCON_PIO_INV_DI 0x00u       /*!<@brief Input not invert */
#define IOCON_PIO_MODE_PULLUP 0x10u  /*!<@brief Selects pull-up function */
#define IOCON_PIO_OD_DI 0x00u        /*!<@brief Disables Open-drain function */
#define IOCON_PIO_SMODE_BYPASS 0x00u /*!<@brief Bypass input filter */

/*! @name SWCLK (number 12), TARGET_SWCLK/J7[4]
  @{ */
/*!
 * @brief PORT device index: 0 */
#define BOARD_INITSWD_DEBUGPINS_DEBUG_SWD_SWCLK_PORT 0U
/*!
 * @brief PORT pin number */
#define BOARD_INITSWD_DEBUGPINS_DEBUG_SWD_SWCLK_PIN 3U
/*!
 * @brief PORT pin mask */
#define BOARD_INITSWD_DEBUGPINS_DEBUG_SWD_SWCLK_PIN_MASK (1U << 3U)
/* @} */

/*! @name SWDIO (number 14), TARGET_SWDIO/J7[2]
  @{ */
/*!
 * @brief PORT device index: 0 */
#define BOARD_INITSWD_DEBUGPINS_DEBUG_SWD_SWDIO_PORT 0U
/*!
 * @brief PORT pin number */
#define BOARD_INITSWD_DEBUGPINS_DEBUG_SWD_SWDIO_PIN 2U
/*!
 * @brief PORT pin mask */
#define BOARD_INITSWD_DEBUGPINS_DEBUG_SWD_SWDIO_PIN_MASK (1U << 2U)
/* @} */


/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitSWD_DEBUGPins(void); /* Function assigned for the Cortex-M0P */

#define IOCON_PIO_CLKDIV0 0x00u      /*!<@brief IOCONCLKDIV0 */
#define IOCON_PIO_HYS_EN 0x20u       /*!<@brief Enable hysteresis */
#define IOCON_PIO_INV_DI 0x00u       /*!<@brief Input not invert */
#define IOCON_PIO_MODE_PULLUP 0x10u  /*!<@brief Selects pull-up function */
#define IOCON_PIO_OD_DI 0x00u        /*!<@brief Disables Open-drain function */
#define IOCON_PIO_SMODE_BYPASS 0x00u /*!<@brief Bypass input filter */

/*! @name PIO0_4 (number 6), SW2/P3[35]/P0_4-WAKEUP
  @{ */

/* Symbols to be used with GPIO driver */
#define BOARD_INITBUTTONSPINS_SW2_GPIO GPIO                /*!<@brief GPIO peripheral base pointer */
#define BOARD_INITBUTTONSPINS_SW2_GPIO_PIN_MASK (1U << 4U) /*!<@brief GPIO pin mask */
#define BOARD_INITBUTTONSPINS_SW2_PORT 0U                  /*!<@brief PORT device index: 0 */
#define BOARD_INITBUTTONSPINS_SW2_PIN 4U                   /*!<@brief PORT pin number */
#define BOARD_INITBUTTONSPINS_SW2_PIN_MASK (1U << 4U)      /*!<@brief PORT pin mask */
                                                           /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitBUTTONsPins(void); /* Function assigned for the Cortex-M0P */

/*!
 * @brief Selects function mode (on-chip pull-up/pull-down resistor control).: Pull-up. Pull-up resistor enabled. */
#define PIO1_16_MODE_PULL_UP 0x02u
/*!
 * @brief Selects function mode (on-chip pull-up/pull-down resistor control).: Pull-up. Pull-up resistor enabled. */
#define PIO1_17_MODE_PULL_UP 0x02u

/*! @name PIO1_17 (number 37), P3[13]/P1_17-TARGET_TX_DEBUG
  @{ */
#define BOARD_INITUSART_DEBUG_UART_TX_PORT 1U                   /*!<@brief PORT device index: 1 */
#define BOARD_INITUSART_DEBUG_UART_TX_PIN 17U                   /*!<@brief PORT pin number */
#define BOARD_INITUSART_DEBUG_UART_TX_PIN_MASK (1U << 17U)      /*!<@brief PORT pin mask */
                                                                /* @} */

/*! @name PIO1_16 (number 36), P3[14]/P1_16-TARGET_RX_DEBUG
  @{ */
#define BOARD_INITUSART_DEBUG_UART_RX_PORT 1U                   /*!<@brief PORT device index: 1 */
#define BOARD_INITUSART_DEBUG_UART_RX_PIN 16U                   /*!<@brief PORT pin number */
#define BOARD_INITUSART_DEBUG_UART_RX_PIN_MASK (1U << 16U)      /*!<@brief PORT pin mask */
                                                                /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitUSART(void); /* Function assigned for the Cortex-M0P */

/*!
 * @brief Mux selection FTM0 fault from external I/O or internal.: Select internal */
#define FTMFLTCFG_FTM0_FAULT0_MUX_SEL_INTERNAL 0x01u

/*! @name PIO1_1 (number 18), P1_1-PWM_CB/J5[5]
  @{ */
#define BOARD_INITFTM0_PWM_CB_PORT 1U                  /*!<@brief PORT device index: 1 */
#define BOARD_INITFTM0_PWM_CB_PIN 1U                   /*!<@brief PORT pin number */
#define BOARD_INITFTM0_PWM_CB_PIN_MASK (1U << 1U)      /*!<@brief PORT pin mask */
                                                       /* @} */

/*! @name PIO0_16 (number 19), P0_16-PWM_CT/J5[7]
  @{ */
#define BOARD_INITFTM0_PWM_CT_PORT 0U                   /*!<@brief PORT device index: 0 */
#define BOARD_INITFTM0_PWM_CT_PIN 16U                   /*!<@brief PORT pin number */
#define BOARD_INITFTM0_PWM_CT_PIN_MASK (1U << 16U)      /*!<@brief PORT pin mask */
                                                        /* @} */

/*! @name PIO1_2 (number 20), P1_2-PWM_BB/J5[9]
  @{ */
#define BOARD_INITFTM0_PWM_BB_PORT 1U                  /*!<@brief PORT device index: 1 */
#define BOARD_INITFTM0_PWM_BB_PIN 2U                   /*!<@brief PORT pin number */
#define BOARD_INITFTM0_PWM_BB_PIN_MASK (1U << 2U)      /*!<@brief PORT pin mask */
                                                       /* @} */

/*! @name PIO0_27 (number 21), P0_27-PWM_BT/J5[11]
  @{ */
#define BOARD_INITFTM0_PWM_BT_PORT 0U                   /*!<@brief PORT device index: 0 */
#define BOARD_INITFTM0_PWM_BT_PIN 27U                   /*!<@brief PORT pin number */
#define BOARD_INITFTM0_PWM_BT_PIN_MASK (1U << 27U)      /*!<@brief PORT pin mask */
                                                        /* @} */

/*! @name PIO1_5 (number 35), J5[13]/P1_5-PWM_AB
  @{ */
#define BOARD_INITFTM0_PWM_AB_PORT 1U                  /*!<@brief PORT device index: 1 */
#define BOARD_INITFTM0_PWM_AB_PIN 5U                   /*!<@brief PORT pin number */
#define BOARD_INITFTM0_PWM_AB_PIN_MASK (1U << 5U)      /*!<@brief PORT pin mask */
                                                       /* @} */

/*! @name PIO1_6 (number 38), J5[15]/P1_6-PWM_AT
  @{ */
#define BOARD_INITFTM0_PWM_AT_PORT 1U                  /*!<@brief PORT device index: 1 */
#define BOARD_INITFTM0_PWM_AT_PIN 6U                   /*!<@brief PORT pin number */
#define BOARD_INITFTM0_PWM_AT_PIN_MASK (1U << 6U)      /*!<@brief PORT pin mask */
                                                       /* @} */

/*! @name PIO0_11 (number 16), P0_11-I2C0_SDA/P3[40]/J1[18]/J3[7]
  @{ */

/* Symbols to be used with GPIO driver */
#define BOARD_INITFTM0_OVERCURRENT_GPIO GPIO                 /*!<@brief GPIO peripheral base pointer */
#define BOARD_INITFTM0_OVERCURRENT_GPIO_PIN_MASK (1U << 11U) /*!<@brief GPIO pin mask */
#define BOARD_INITFTM0_OVERCURRENT_PORT 0U                   /*!<@brief PORT device index: 0 */
#define BOARD_INITFTM0_OVERCURRENT_PIN 11U                   /*!<@brief PORT pin number */
#define BOARD_INITFTM0_OVERCURRENT_PIN_MASK (1U << 11U)      /*!<@brief PORT pin mask */
                                                             /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitFTM0(void); /* Function assigned for the Cortex-M0P */

/*! @name ADC_6 (number 58), J1[1]/J2[14/P3[45/P0_20-BEMF_A
  @{ */
#define BOARD_INITADC_CUR_A_PORT 0U                   /*!<@brief PORT device index: 0 */
#define BOARD_INITADC_CUR_A_PIN 20U                   /*!<@brief PORT pin number */
#define BOARD_INITADC_CUR_A_PIN_MASK (1U << 20U)      /*!<@brief PORT pin mask */
                                                      /* @} */

/*! @name ADC_7 (number 60), J1[3]/J2[16]/P3[44]/P0_19-BEMF_B
  @{ */
#define BOARD_INITADC_CUR_B_PORT 0U                   /*!<@brief PORT device index: 0 */
#define BOARD_INITADC_CUR_B_PIN 19U                   /*!<@brief PORT pin number */
#define BOARD_INITADC_CUR_B_PIN_MASK (1U << 19U)      /*!<@brief PORT pin mask */
                                                      /* @} */

/*! @name ADC_8 (number 61), J1[5]/J1[6]/P3[43]/P0_18-BEMF_C
  @{ */
#define BOARD_INITADC_CUR_C_PORT 0U                   /*!<@brief PORT device index: 0 */
#define BOARD_INITADC_CUR_C_PIN 18U                   /*!<@brief PORT pin number */
#define BOARD_INITADC_CUR_C_PIN_MASK (1U << 18U)      /*!<@brief PORT pin mask */
                                                      /* @} */

/*! @name ADC_9 (number 63), J1[7]/J1[8]/P3[42]/P0_17-VOLT_DCB
  @{ */
#define BOARD_INITADC_VOLT_DCB_PORT 0U                   /*!<@brief PORT device index: 0 */
#define BOARD_INITADC_VOLT_DCB_PIN 17U                   /*!<@brief PORT pin number */
#define BOARD_INITADC_VOLT_DCB_PIN_MASK (1U << 17U)      /*!<@brief PORT pin mask */
                                                         /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitADC(void); /* Function assigned for the Cortex-M0P */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitACOMP(void); /* Function assigned for the Cortex-M0P */

#if defined(__cplusplus)
}
#endif

/*!
 * @}
 */
#endif /* _PIN_MUX_H_ */

/***********************************************************************************************************************
 * EOF
 **********************************************************************************************************************/
